﻿<%@ Application language="C#" %>
 <%@ Import Namespace="System.Configuration" %>
 <%@ Import Namespace="System.Security.Principal" %>

 <script runat="server">
     public void Application_OnAuthenticateRequest(Object sender, EventArgs e) {
         HttpApplication app = (HttpApplication)sender;
         string strAuth = app.Request.Headers["Authorization"];

         if (strAuth == null || strAuth.Length == 0) {
             // 認証用のヘッダ(Authorization)がない場合
             return;
         }

         // 念のためトリミング
         strAuth = strAuth.Trim();

         if (strAuth.IndexOf("Basic", 0) != 0) {
             // 認証用のヘッダの構文がおかしい場合
             return;
         }

         // 「Basic 」以降の文字列を抽出
         string encodedString = strAuth.Substring(6);

         // BASE64をデコードする
         byte[] decodedBytes = Convert.FromBase64String(encodedString);
         string decodedString = new ASCIIEncoding().GetString(decodedBytes);

         // ユーザー名とパスワードを分離
         string[] arrSplited = decodedString.Split(new char[] {':'});
         string username = arrSplited[0];
         string password = arrSplited[1];

         // 認証処理
         string[] roles;
         if (AuthenticateUser(username, password, out roles)) {
             // セキュリティ情報を設定
             app.Context.User = new GenericPrincipal(new GenericIdentity(username), roles);

         } else {
             // 認証に失敗した場合はアクセス拒否の情報をセットする
             app.Response.StatusCode = 401;
             app.Response.StatusDescription = "Unauthorized";

             // 認証に失敗したことを通知する
             app.Response.Write("<html>\r\n<head>\r\n<title>");
             app.Response.Write("401 Unauthorized</title>\r\n</head>\r\n<body>\r\n");
             app.Response.Write("<h1>401 Access Denied</h1>\r\n");
             app.Response.Write("</body>\r\n</html>\r\n");

             app.CompleteRequest();

             return;

         }
     }

     public void Application_OnEndRequest(Object sender, EventArgs e) {
         HttpApplication app = (HttpApplication)sender;

         // 認証が成功していない場合は「WWW-Authenticate」ヘッダを付加する
         if (app.Response.StatusCode == 401) {
             string strRealm = ConfigurationSettings.AppSettings["AuthRealm"];
                    strRealm = "Basic Realm=" + strRealm;
             app.Response.AppendHeader("WWW-Authenticate", strRealm);
         }
     }

     private bool AuthenticateUser(string username, string password, out string[] roles) {
         bool ret = false;
         
         // 認証処理
         if (username == "foo" && password == "bar") {
             ret = true;
         }

         // ユーザーに割り当てるロールを作成
         roles = new string[1] {"Users"};

         return ret;
     }
 </script>